;
;   L O A D G U I
;
; This file contains a routine that initializes GUI. Without initialization,
; GUI will not work. The routine will load the redirector and check for a
; minimum GUI version. A list of GUI version numbers can be found in the GUI
; include file. Use a "#define GUI_MIN_VERSION GUI_VERSION_xx" before this
; code to specify the version. If you wish to allow any version, simply
; define it to equal zero.
;
; Note that errors should be handled by the calling program (that means you!)
; in such a way as to notify the user of what is wrong.
;
; This routine WILL NOT WORK if the GUI appvar has been archived. If you wish to
;  handle that as an error, include a "ld a,b \ or a \ scf \ ret nz" after the
;  "ret c".
;
; _chkfindsym must be defined to use this routine.
;

#ifndef GUI_MIN_VERSION
#define GUI_MIN_VERSION 0
#endif

;------------------------------------------------------------------------------------;


; Load the GUI redirector for use in your programs. Also checks for a minimum version.
; Must be called before using any of GUI's routines.
; Inputs: None
; Outputs: carry flag set if failure (app not installed or version not met).
; Destroyed: af,bc,de,hl

guiInit:			;Total: 20 bytes
	ld hl,guiAppVar		;3
	rst 20h			;1	Put the appvar's name into op1
	bcall(_chkfindsym)	;3	Find it
	ret c			;1	If it doesn't exist, return ca=1
	inc de			;1
	inc de			;1	Move to first data byte
	ld c,GUI_MIN_VERSION	;2	Get the minimum version
	push de			;1
	ret			;1	Jump to de
guiAppVar:
	.db $15,"GUI",0	;6	Name of the GUI Appvar


;------------------------------------------------------------------------------------;
