; Text Display Routines
;
; multilinetextL
; multilinetextC
; centertext
; nextstr
; vputmap2
; vputs2
; multilinetextL2
; multilinetextC2
; pixlen
;

multilinetextL:
 ld (pencol),de
 ld a,(hl)
 inc hl
 or a
 ret z
multilinetextL_loop1:
 B_CALL _vputs
 ex de,hl
 bit fracDrawLFont,(iy+fontFlags)
 jr z,multilinetextL_small
 ld bc,8*256+0
 jr multilinetextL_big
multilinetextL_small:
 ld bc,6*256+0
multilinetextL_big:
 add hl,bc
 ld (pencol),hl
 ex de,hl
 dec a
 jr nz,multilinetextL_loop1
 ret


multilinetextC:
 ld (pencol),de
 ld a,(hl)
 inc hl
 or a
 ret z
multilinetextC_loop1:
 push de
 push bc
 push af
 push ix
 call centertext
 pop ix
 pop af
 pop bc
 pop de
 ex de,hl
 bit fracDrawLFont,(iy+fontFlags)
 jr z,multilinetextC_small
 ld bc,8*256+0
 jr multilinetextC_big
multilinetextC_small:
 ld bc,6*256+0
multilinetextC_big:
 add hl,bc
 ld (pencol),hl
 ex de,hl
 dec a
 jr nz,multilinetextC_loop1
 ret


centertext:
 ld c,0
 push hl
centertext_loop1:
 ld a,(hl)
 inc hl
 or a
 jr z,centertext_noloop
 push hl
 ld l,a
 ld h,0
 add hl,hl
 add hl,hl
 add hl,hl
 bit fracDrawLFont,(iy+fontFlags)
 jr z,centertext_small
 ld b,6
 jr centertext_big
centertext_small:
 B_CALL _sfont_len
centertext_big:
 ld a,c
 add a,b
 ld c,a
 pop hl
 jr centertext_loop1
centertext_noloop:
 pop hl
 sra c
 ld a,(pencol)
 sub c
 ld (pencol),a
 B_CALL _vputs
 ret


nextstr:
 push af
 push bc
 xor a
 ld b,a
 ld c,a
 cpir
 pop bc
 pop af
 ret

vputmap2:
 push bc
 push af
 ld bc,(pencol)
 push ix
 B_CALL _vputmap
 pop ix
 ld (pencol),bc
 ld a,(flags+sgrflags)
 ld b,a
 xor 1<<textwrite
 ld (flags+sgrflags),a
 pop af
 push ix
 B_CALL _vputmap
 pop ix
 ld a,b
 ld (flags+sgrflags),a
 pop bc
 ret

vputs2:
 push af
 push de
 ld a,(flags+sgrflags)
 push af
 push hl
 ld de,(pencol)
 B_CALL _vputs
 ld (pencol),de
 xor 1<<textwrite
 ld (flags+sgrflags),a
 pop hl
 B_CALL _vputs
 pop af
 ld (flags+sgrflags),a
 pop de
 pop af
 ret


multilinetextL2:
 ld (pencol),de
 ld a,(hl)
 inc hl
 or a
 ret z
multilinetextL2_loop1:
 call vputs2
 ex de,hl
 bit fracDrawLFont,(iy+fontFlags)
 jr z,multilinetextL2_small
 ld bc,8*256+0
 jr multilinetextL2_big
multilinetextL2_small:
 ld bc,6*256+0
multilinetextL2_big:
 add hl,bc
 ld (pencol),hl
 ex de,hl
 dec a
 jr nz,multilinetextL2_loop1
 ret


multilinetextC2:
 ld (pencol),de
 ld a,(hl)
 inc hl
 or a
 ret z
multilinetextC2_loop1:
 push de
 push bc
 push af
 push ix
 call centertext2
 pop ix
 pop af
 pop bc
 pop de
 ex de,hl
 bit fracDrawLFont,(iy+fontFlags)
 jr z,multilinetextC2_small
 ld bc,8*256+0
 jr multilinetextC2_big
multilinetextC2_small:
 ld bc,6*256+0
multilinetextC2_big:
 add hl,bc
 ld (pencol),hl
 ex de,hl
 dec a
 jr nz,multilinetextC2_loop1
 ret

centertext2:
 ld c,0
 push hl
centertext2_loop1:
 ld a,(hl)
 inc hl
 or a
 jr z,centertext2_noloop
 push hl
 ld l,a
 ld h,0
 add hl,hl
 add hl,hl
 add hl,hl
 bit fracDrawLFont,(iy+fontFlags)
 jr z,centertext2_small
 ld b,6
 jr centertext2_big
centertext2_small:
 B_CALL _sfont_len
centertext2_big:
 ld a,c
 add a,b
 ld c,a
 pop hl
 jr centertext2_loop1
centertext2_noloop:
 pop hl
 sra c
 ld a,(pencol)
 sub c
 ld (pencol),a
 call vputs2
 ret


pixlen:
 ld c,0
 push de
 push af
 push hl
pixlen_loop1:
 ld a,(hl)
 inc hl
 or a
 jr z,pixlen_noloop
 push hl
 ld b,6
 bit fracDrawLFont,(iy+fontFlags)
 jr nz,pixlen_big
 ld l,a
 ld h,0
 add hl,hl
 add hl,hl
 add hl,hl
 B_CALL _sfont_len
pixlen_big:
 ld a,c
 add a,b
 ld c,a
 pop hl
 jr pixlen_loop1
pixlen_noloop:
 pop hl
 pop af
 pop de
 dec c
 ld b,7
 bit fracDrawLFont,(iy+fontFlags)
 ret nz
 ld b,5
 ret

